﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;
using System.Timers;
using System.Threading;
using BNSharp.BattleNet;
using BNSharp.Plugins;
using BNSharp.Net;
using BNSharp;
using Microsoft.VisualBasic;
using System.IO;
using System.Net;
using ICSharpCode.SharpZipLib.Zip;
using ICSharpCode.SharpZipLib.Checksums;


namespace Bot
{
    class Settings : BNSharp.IBattleNetSettings
    {
        #region IBattleNetSettings Members
        public PingType PingMethod
        {
            get;
            set;
        }
        public string Client
        {
            get;
            set;
        }
        public int VersionByte
        {
            get;
            set;
        }
        public string CdKey1
        {
            get;
            set;
        }
        public string CdKey2
        {
            get;
            set;
        }
        public string GameExe
        {
            get;
            set;
        }
        public string GameFile2
        {
            get;
            set;
        }
        public string GameFile3
        {
            get;
            set;
        }
        public string Username
        {
            get;
            set;
        }
        public string ImageFile
        {
            get;
            set;
        }
        public string Password
        {
            get;
            set;
        }
        public string Server
        {
            get;
            set;
        }
        public int Port
        {
            get;
            set;
        }
        public string CdKeyOwner
        {
            get;
            set;
        }
        public string HomeChannel
        {
            get;
            set;
        }
        #endregion

        #region botsettings
        public string Trigger
        {
            get;
            set;
        }
        public string channel
        {
            get;
            set;
        }
        public bool pingban
        {
            get;
            set;
        }
        public bool automod
        {
            get;
            set;
        }
        public bool lockdown
        {
            get;
            set;
        }
        public string pingbans
        {
            get;
            set;
        }
        public bool isd2
        {
            get;
            set;
        }
        public void save()
        {
            string basepath = Environment.CurrentDirectory;
            string filename;
            filename = basepath.Insert(basepath.Length, @"\config.txt");
            System.IO.StreamWriter objWriter;
            objWriter = new System.IO.StreamWriter(filename);
            objWriter.WriteLine("[Config]");
            objWriter.WriteLine("Username=" + Username);
            objWriter.WriteLine("Password=" + Password);
            objWriter.WriteLine("CDKey=" + CdKey1);
            objWriter.WriteLine("CDKeyXP=" + CdKey2);
            objWriter.WriteLine("Server=" + Server);
            objWriter.WriteLine("CDKeyOwner=" + CdKeyOwner);
            objWriter.WriteLine("Client=" + Client);
            objWriter.WriteLine("Trigger=" + Trigger);
            objWriter.WriteLine("Channel=" + channel);
            objWriter.WriteLine("Pingban=" + pingban);
            objWriter.WriteLine("Pingbans=" + pingbans);
            objWriter.WriteLine("Automod=" + automod);
            objWriter.WriteLine("Lockdown=" + lockdown);
            objWriter.Close();
        }
        public void load()
        {
            string basepath = Environment.CurrentDirectory;
            if (!exists(basepath + @"\verbytes.txt"))
            {
                WebClient Web = new WebClient();
                Web.DownloadFile("http://mikeownage.com/downloads/shubot/verbytes.txt", "verbytes.txt");
                Console.WriteLine("verbytes.txt not found downloading...");
            }
            string filename;
            string txtline = null;
            if (!exists(basepath + @"\config.txt"))
            {
                save();
                Console.WriteLine("Please open config.txt and insert your information!");
            }
            filename = basepath.Insert(basepath.Length, @"\config.txt");
            System.IO.StreamReader objReader;
            objReader = new System.IO.StreamReader(filename);

            do
            {
                txtline = objReader.ReadLine();
                string txtline1 = txtline;
                if (txtline.Contains("="))
                {
                    string[] splt = txtline.Split('=');
                    splt[0] = splt[0].ToLower();
                    if (splt[0] == "username" && splt[1] != "")
                    {
                        Username = splt[1];
                    }
                    if (splt[0] == "lockdown" && splt[1] != "")
                    {
                        lockdown = System.Convert.ToBoolean(splt[1]);
                    }
                    if (splt[0] == "password" && splt[1] != "")
                    {
                        Password = splt[1];
                    }
                    if (splt[0] == "cdkey" && splt[1] != "")
                    {
                        CdKey1 = splt[1];
                    }
                    if (splt[0] == "cdkeyxp" && splt[1] != "")
                    {
                        CdKey2 = splt[1];
                    }
                    if (splt[0] == "server" && splt[1] != "")
                    {
                        Server = splt[1];
                    }
                    if (splt[0] == "cdkeyowner" && splt[1] != "")
                    {
                        CdKeyOwner = splt[1];
                    }
                    if (splt[0] == "trigger" && splt[1] != "")
                    {
                        Trigger = splt[1];
                    }
                    if (splt[0] == "channel" && splt[1] != "")
                    {
                        channel = splt[1];
                        HomeChannel = splt[1];
                    }
                    if (splt[0] == "pingban" && splt[1] != "")
                    {
                        pingban = System.Convert.ToBoolean(splt[1]);
                    }
                    if (splt[0] == "automod" && splt[1] != "")
                    {
                        pingban = System.Convert.ToBoolean(splt[1]);
                    }
                    if (splt[0] == "pingbans" && splt[1] != "")
                    {
                        pingbans = txtline1.Remove(0, 9);
                    }
                    if (splt[0] == "client")
                    {
                        Client = splt[1];
                        string x = splt[1].ToUpper();
                        if (x == "")
                        {
                            Client = "FAIL";
                        }
                        else
                        {
                            if (x == "STAR")
                            {
                                ImageFile = basepath.Insert(basepath.Length, @"\Hashes\STAR\STAR.bin");
                                GameExe = basepath.Insert(basepath.Length, @"\Hashes\STAR\Starcraft.exe");
                                GameFile2 = basepath.Insert(basepath.Length, @"\Hashes\STAR\Storm.dll");
                                GameFile3 = basepath.Insert(basepath.Length, @"\Hashes\STAR\Battle.snp");
                                VersionByte = getverbyte(x);
                                PingMethod = PingType.Normal;
                                Port = 6112;
                                if (exists(basepath.Insert(basepath.Length, @"\Hashes\STAR\Starcraft.exe")))
                                {
                                }
                                else
                                {
                                    Console.WriteLine("Hashes not found downloading...");
                                    WebClient Web = new WebClient();
                                    Web.DownloadFile("http://mikeownage.com/downloads/battle.net/STAR.zip", "STAR.zip");
                                    UnZip.Unzipfile(basepath + @"\STAR.zip", basepath.Insert(basepath.Length, @"\Hashes\"));
                                    File.Delete(basepath + @"\STAR.zip");
                                }
                            }
                            if (x == "SEXP")
                            {
                                ImageFile = basepath.Insert(basepath.Length, @"\Hashes\STAR\STAR.bin");
                                GameExe = basepath.Insert(basepath.Length, @"\Hashes\STAR\Starcraft.exe");
                                GameFile2 = basepath.Insert(basepath.Length, @"\Hashes\STAR\Storm.dll");
                                GameFile3 = basepath.Insert(basepath.Length, @"\Hashes\STAR\Battle.snp");
                                VersionByte = getverbyte(x);
                                PingMethod = PingType.Normal;
                                Port = 6112;
                                if (exists(basepath.Insert(basepath.Length, @"\Hashes\STAR\Starcraft.exe")))
                                {
                                }
                                else
                                {
                                    Console.WriteLine("Hashes not found downloading...");
                                    WebClient Web = new WebClient();
                                    Web.DownloadFile("http://mikeownage.com/downloads/battle.net/STAR.zip", "STAR.zip");
                                    UnZip.Unzipfile(basepath + @"\STAR.zip", basepath.Insert(basepath.Length, @"\Hashes\"));
                                    File.Delete(basepath + @"\STAR.zip");
                                }
                            }
                            if (x == "W2BN")
                            {
                                ImageFile = basepath.Insert(basepath.Length, @"\Hashes\W2BN\W2BN.bin");
                                GameExe = basepath.Insert(basepath.Length, @"\Hashes\W2BN\Warcraft II BNE.exe");
                                GameFile2 = basepath.Insert(basepath.Length, @"\Hashes\W2BN\Storm.dll");
                                GameFile3 = basepath.Insert(basepath.Length, @"\Hashes\W2BN\Battle.snp");
                                VersionByte = getverbyte(x);
                                PingMethod = PingType.Normal;
                                Port = 6112;
                                if (exists(basepath.Insert(basepath.Length, @"\Hashes\W2BN\Warcraft II BNE.exe")))
                                {
                                }
                                else
                                {
                                    Console.WriteLine("Hashes not found downloading...");
                                    WebClient Web = new WebClient();
                                    Web.DownloadFile("http://mikeownage.com/downloads/battle.net/W2BN.zip", "W2BN.zip");
                                    UnZip.Unzipfile(basepath + @"\W2BN.zip", basepath.Insert(basepath.Length, @"\Hashes\"));
                                    File.Delete(basepath + @"\W2BN.zip");
                                }
                            }
                            if (x == "D2DV")
                            {
                                isd2 = true;
                                GameExe = basepath.Insert(basepath.Length, @"\Hashes\D2DV\game.exe");
                                GameFile2 = basepath.Insert(basepath.Length, @"\Hashes\D2DV\Bnclient.dll");
                                GameFile3 = basepath.Insert(basepath.Length, @"\Hashes\D2DV\D2Client.dll");
                                VersionByte = getverbyte(x);
                                PingMethod = PingType.Normal;
                                Port = 6112;
                                if (exists(basepath.Insert(basepath.Length, @"\Hashes\D2DV\game.exe")))
                                {
                                }
                                else
                                {
                                    Console.WriteLine("Hashes not found downloading...");
                                    WebClient Web = new WebClient();
                                    Web.DownloadFile("http://mikeownage.com/downloads/battle.net/D2DV.zip", "D2DV.zip");
                                    UnZip.Unzipfile(basepath + @"\D2DV.zip", basepath.Insert(basepath.Length, @"\Hashes\"));
                                    File.Delete(basepath + @"\D2DV.zip");
                                }
                            }
                            if (x == "D2XP")
                            {
                                isd2 = true;
                                GameExe = basepath.Insert(basepath.Length, @"\Hashes\D2XP\game.exe");
                                GameFile2 = basepath.Insert(basepath.Length, @"\Hashes\D2XP\Bnclient.dll");
                                GameFile3 = basepath.Insert(basepath.Length, @"\Hashes\D2XP\D2Client.dll");
                                VersionByte = getverbyte(x);
                                PingMethod = PingType.Normal;
                                Port = 6112;
                                if (exists(basepath.Insert(basepath.Length, @"\Hashes\D2XP\game.exe")))
                                {
                                }
                                else
                                {
                                    Console.WriteLine("Hashes not found downloading...");
                                    WebClient Web = new WebClient();
                                    Web.DownloadFile("http://mikeownage.com/downloads/battle.net/D2DV.zip", "D2XP.zip");
                                    UnZip.Unzipfile(basepath + @"\D2XP.zip", basepath.Insert(basepath.Length, @"\Hashes\"));
                                    File.Delete(basepath + @"\D2XP.zip");
                                }
                            }
                            if (x == "WAR3")
                            {
                                GameExe = basepath.Insert(basepath.Length, @"\Hashes\WAR3\war3.exe");
                                GameFile2 = basepath.Insert(basepath.Length, @"\Hashes\WAR3\Storm.dll");
                                GameFile3 = basepath.Insert(basepath.Length, @"\Hashes\WAR3\game.dll");
                                VersionByte = getverbyte(x);
                                PingMethod = PingType.Normal;
                                Port = 6112;
                                if (exists(basepath.Insert(basepath.Length, @"\Hashes\WAR3\war3.exe")))
                                {
                                }
                                else
                                {
                                    Console.WriteLine("Hashes not found downloading...");
                                    WebClient Web = new WebClient();
                                    Web.DownloadFile("http://mikeownage.com/downloads/battle.net/WAR3.zip", "WAR3.zip");
                                    UnZip.Unzipfile(basepath + @"\WAR3.zip", basepath.Insert(basepath.Length, @"\Hashes\"));
                                    File.Delete(basepath + @"\WAR3.zip");
                                }
                            }
                            if (x == "W3XP")
                            {
                                GameExe = basepath.Insert(basepath.Length, @"\Hashes\WAR3\war3.exe");
                                GameFile2 = basepath.Insert(basepath.Length, @"\Hashes\WAR3\Storm.dll");
                                GameFile3 = basepath.Insert(basepath.Length, @"\Hashes\WAR3\game.dll");
                                VersionByte = getverbyte(x);
                                PingMethod = PingType.Normal;
                                Port = 6112;
                                if (exists(basepath.Insert(basepath.Length, @"\Hashes\WAR3\war3.exe")))
                                {
                                }
                                else
                                {
                                    Console.WriteLine("Hashes not found downloading...");
                                    WebClient Web = new WebClient();
                                    Web.DownloadFile("http://mikeownage.com/downloads/battle.net/WAR3.zip", "WAR3.zip");
                                    UnZip.Unzipfile(basepath + @"\WAR3.zip", basepath.Insert(basepath.Length, @"\Hashes\"));
                                    File.Delete(basepath + @"\WAR3.zip");
                                }
                            }
                        }
                    }
                }
            } while (objReader.Peek() != -1);
            objReader.Dispose();
            objReader.Close();
        }
        static int getverbyte(string thegame)
        {
            string basepath = Environment.CurrentDirectory;
            string filename;
            string txtline = null;
            filename = basepath.Insert(basepath.Length, @"\verbytes.txt");
            System.IO.StreamReader objReader;
            objReader = new System.IO.StreamReader(filename);

            do
            {
                txtline = objReader.ReadLine();
                string txtline1 = txtline;
                if (txtline.Contains("="))
                {
                    string[] splt = txtline.Split('=');
                    splt[0] = splt[0].ToLower();
                    if (splt[0] == thegame.ToLower())
                    {
                        objReader.Dispose();
                        objReader.Close();
                        return int.Parse(splt[1]);
                    }
                }
            } while (objReader.Peek() != -1);
            objReader.Dispose();
            objReader.Close();
            return 0;
        }
        #endregion

        #region fileexists
        static bool exists(string filename)
        {
            return File.Exists(filename);
        }
        #endregion
    }

    class Program
    {
        #region declares
        static string myver = @"OpsBot v0.7.4 Build: 20 by Mike@USEast";
        static clsTagban tagban = new clsTagban();
        static clsAutoban autoban = new clsAutoban();
        static System.Timers.Timer QT = new System.Timers.Timer();
        static System.Timers.Timer QT1 = new System.Timers.Timer();
        static System.Timers.Timer QT2 = new System.Timers.Timer();
        static ArrayList bnetqueue = new ArrayList();
        static Settings set = new Settings();
        static List<clsChannel> channel = new List<clsChannel>();
        static List<clsDatabase> botdb = new List<clsDatabase>();
        static string uniuser;
        static string toddp;
        static bool firstjoin = true;
        static bool ops = false;
        static bool exit = false;
        static BNSharp.BattleNet.BattleNetClient client;
        static ArrayList shamans = new ArrayList();
        static int QT1Count = 0;
        static long QT2Count = 0;
        static bool downloadhashes = false;
        static DateTime botuptime = DateTime.Now;
        #endregion

        #region core
        static void Main(string[] args)
        {
            if (!Directory.Exists("Hashes"))
            {
                Directory.CreateDirectory("Hashes");
            }
            databaseload();
            tagban.load();
            autoban.load();
            QT.Elapsed += new ElapsedEventHandler(QT_Finshed);
            QT.Interval = 1;
            QT.Start();
            QT1.Elapsed += new ElapsedEventHandler(QT1_Finshed);
            QT2.Elapsed += new ElapsedEventHandler(QT2_Finshed);
            QT2.Interval = 1000;
            QT2.Start();
            QT2Count = 12000;
            set.load();
            databasesave();
            set.save();
            BNSharp.BattleNet.BattleNetClient client1 = new BNSharp.BattleNet.BattleNetClient(set);
            client = client1;
            Console.Title = set.Username + " : " + myver;

            #region registerevents
            client.WhisperReceived += new BNSharp.ChatMessageEventHandler(client_WhisperReceived);
            client.UserShown += new BNSharp.UserEventHandler(client_UserShown);
            client.Connected += delegate { Console.WriteLine("Connected to {0}", client.Settings.Server); };
            client.Error += new BNSharp.ErrorEventHandler(client_Error);
            client.EventExceptionThrown += new BNSharp.EventExceptionEventHandler(client_EventExceptionThrown);
            client.LoginSucceeded += delegate { Console.WriteLine("Login accepted for {0}", client.Settings.Username); };
            client.UserLeft += new BNSharp.UserEventHandler(client_UserLeft);
            client.ServerBroadcast += new BNSharp.ServerChatEventHandler(client_ServerBroadcast);
            client.Information += new BNSharp.InformationEventHandler(client_Information);
            client.InformationReceived += new BNSharp.ServerChatEventHandler(client_InformationReceived);
            client.EnteredChat += new BNSharp.EnteredChatEventHandler(client_EnteredChat);
            client.JoinedChannel += new BNSharp.ServerChatEventHandler(client_JoinedChannel);
            client.UserFlagsChanged += new BNSharp.UserEventHandler(client_UserFlagsChanged);
            client.UserEmoted += new BNSharp.ChatMessageEventHandler(client_UserEmoted);
            client.ClanMemberListReceived += new BNSharp.BattleNet.Clans.ClanMemberListEventHandler(client_CList);
            client.ClanRankChanged += new BNSharp.BattleNet.Clans.ClanRankChangeEventHandler(client_clan_rankchange);
            client.ClanMemberStatusChanged += new BNSharp.BattleNet.Clans.ClanMemberStatusEventHandler(client_clan_memberstatus);
            client.ClientCheckFailed += new BNSharp.ClientCheckFailedEventHandler(client_HashResult);
            client.UserSpoke += new BNSharp.ChatMessageEventHandler(client_UserSpoke);
            client.UserJoined += new BNSharp.UserEventHandler(client_UserJoined);
            #endregion

            //client.WardenHandler = bncswarden;
            //client.WardenHandler

            if (set.Client.ToUpper() == "STAR" || set.Client.ToUpper() == "SEXP")
            {
                Console.WriteLine("STARCRAFT AND STARCRAFT BROODWAR ARE NOT SUPPORTED AT THIS TIME");
            }
            else
            {
                if (set.Username != null)
                {
                    client.Connect();
                }
                else
                {
                    Console.WriteLine("Please edit config.txt");
                }
            }
            string text;
            do
            {
                text = Console.ReadLine();

                #region exit
                if (text.ToLower().Equals("/exit", StringComparison.Ordinal))
                {
                    exit = true;
                }
                #endregion

                #region channel
                else if (text.ToLower().Equals("/channel", StringComparison.Ordinal))
                {
                    showchannel();
                }
                #endregion

                #region reload
                else if (text.ToLower().Equals("/reload", StringComparison.Ordinal))
                {
                    set.load();
                    databaseload();
                    tagban.load();
                    autoban.load();
                }
                #endregion

                #region other
                else
                {
                    if (downloadhashes)
                    {
                        exit = true;
                        break;
                    }
                    qtadd(text, false, "");
                }
                #endregion

            } while (!exit);

            client.Close();
            Console.WriteLine("<" + DateTime.Now.TimeOfDay + "> Disconnected; press <enter> to exit.");
            Console.ReadLine();
        }
        static void showchannel()
        {
            List<clsChannel> inchannel = channel.FindAll(delegate(clsChannel u) { return u.inchannel == true; });
            Console.WriteLine("USERS IN CHANNEL {0}: CURRENT TICK - {1}", inchannel.Count, DateTime.Now.Ticks);
            inchannel.ForEach(delegate(clsChannel u) { Console.WriteLine("Username: {0}, Ping: {1}, Client: {2}, Ops: {3}, Join:{4}, LastMessage: {5}, Banned:{6}", u.username, u.ping, u.client, u.isops, u.jointime, u.lasttalk, u.banned); });
        }
        static string BotUptime()
        {
            TimeSpan Uptime = new TimeSpan();
            Uptime = TimeSpan.FromMilliseconds(DateTime.Now.Subtract(botuptime).TotalMilliseconds);
            return "Bot Uptime: " + Uptime.Days + " days, " + Uptime.Hours + " hours, " + Uptime.Minutes + " minutes, " + Uptime.Seconds + " seconds.";
        }
        static string SystemUptime()
        {
            TimeSpan Uptime = new TimeSpan();
            Uptime = TimeSpan.FromMilliseconds(System.Environment.TickCount);
            return "System Uptime: " + Uptime.Days + " days, " + Uptime.Hours + " hours, " + Uptime.Minutes + " minutes, " + Uptime.Seconds + " seconds.";
        }
        static int rnd(int min, int max)
        {
            Random random = new Random();
            return random.Next(min, max);
        }
        static bool toggle(bool x)
        {
            if (!x)
            {
                return true;
            }
            else
            {
                return false;
            }

        }
        static string status(bool x)
        {
            if (x)
            {
                return "Enabled";
            }
            else
            {
                return "Disabled";
            }
        }

        #endregion

        #region Commands
        static void commands(string username, string message, bool whisper)
        {
            if (message.Contains(' '))
            {
                string[] bnettext = message.Split(' ');
                string command = bnettext[0];
                command = command.ToLower();

                #region pingban
                if (command == "pingban" || command == "pingbans")
                {
                    if (databasegetaccess(username) >= 7)
                    {
                        set.pingbans = bnettext[1];
                        qtadd("Pingbans are now set to: " + set.pingbans, whisper, username);
                        set.save();
                    }
                }
                #endregion

                #region settrigger
                if (command == "settrigger")
                {
                    if (databasegetaccess(username) > 8)
                    {
                        set.Trigger = bnettext[1];
                        set.save();
                        if (set.Trigger.Length > 1)
                        {
                            char[] a = set.Trigger.ToCharArray();
                            string RAWR = "";
                            for (int i = 0; i != a.Length; i++)
                            {
                                int b = (int)a[i];
                                if (i == 0)
                                {
                                    if (b < 100)
                                    {
                                        RAWR = "Trigger is set to " + set.Trigger + " [ Alt + 0" + b + " ";
                                    }
                                    else
                                    {
                                        RAWR = "Trigger is set to " + set.Trigger + " [ Alt + " + b + " ";
                                    }
                                }
                                else if (i == (a.Length - 1))
                                {
                                    if (b < 100)
                                    {
                                        RAWR = RAWR + "0" + b + "]";
                                    }
                                    else
                                    {
                                        RAWR = RAWR + b + "]";
                                    }
                                }
                                else
                                {
                                    if (b < 100)
                                    {
                                        RAWR = RAWR + "0" + b + " ";
                                    }
                                    else
                                    {
                                        RAWR = RAWR + b + " ";
                                    }
                                }

                            }
                            qtadd(RAWR, whisper, username);
                        }
                        else
                        {
                            char a = System.Convert.ToChar(set.Trigger);
                            int b = (int)a;
                            if (b < 100)
                            {
                                qtadd("Trigger is set to " + set.Trigger + " [ Alt + 0" + b + " ] ", whisper, username);
                            }
                            else
                            {
                                qtadd("Trigger is set to " + set.Trigger + " [ Alt + " + b + " ] ", whisper, username);
                            }
                        }
                    }
                }
                #endregion

                #region setmotd
                if (command == "setmotd")
                {
                    if (databasegetaccess(username) > 8)
                    {
                        if (set.Client.ToUpper() == "WAR3" || set.Client.ToUpper() == "W3XP")
                        {
                            string tosend;
                            tosend = bnettext[1];
                            for (int i = 2; i < bnettext.Length; i++)
                            {
                                tosend = tosend + " " + bnettext[i];
                            }
                            client.SetClanMessageOfTheDay(tosend);
                            Console.WriteLine("New clan message set to: ", tosend);
                        }
                    }
                }
                #endregion

                #region setrank
                if (command == "setrank")
                {
                    if (databasegetaccess(username) > 8)
                    {
                        int kk = bnettext.Count();
                        if (kk > 1)
                        {

                            //.InsertDWORD 1
                            //.InsertDWORD 3
                            //.InsertNTString Username
                            //.InsertNTString "Profile\Sex"
                            //.InsertNTString "Profile\Location"
                            //.InsertNTString "Profile\Description"
                            //.InsertNTString Sex
                            //.InsertNTString Loc
                            //.InsertNTString Des
                            //.SendBNCS Index, &H27

                            BNSharp.MBNCSUtil.BncsPacket newpacket = new BNSharp.MBNCSUtil.BncsPacket(0x27);
                            newpacket.InsertDwordString((string)1);
                            newpacket.InsertCString(bnettext[1]);
                            switch (bnettext[2].ToLower().ToString())
                            {
                                case "peon":
                                    newpacket.InsertByte(0x01);
                                    client.Send(newpacket);
                                    break;
                                case "grunt":
                                    newpacket.InsertByte(0x02);
                                    client.Send(newpacket);
                                    break;
                                case "shaman":
                                    newpacket.InsertByte(0x03);
                                    client.Send(newpacket);
                                    break;
                            }
                            Console.WriteLine("Set {0} To Rank {1}", bnettext[1], bnettext[2]);
                        }
                    }
                }

                #endregion

                #region autoban
                if (command == "autoban")
                {
                    int a = databasegetaccess(username);
                    int b = databasegetaccess(bnettext[1]);
                    if (a >= 7)
                    {
                        if (a > b)
                        {
                            if (autoban.get(bnettext[1].ToLower()))
                            {
                                qtadd("Removing autoban " + bnettext[1] + ".", whisper, username);
                                autoban.rem(bnettext[1].ToLower());
                                autoban.save();
                                qtadd(@"/unban " + bnettext[1], false, username);
                            }
                            else
                            {
                                qtadd("Adding autoban " + bnettext[1] + ".", whisper, username);
                                autoban.add(bnettext[1].ToLower());
                                autoban.save();
                                qtadd(@"/ban " + bnettext[1] + " Autoban", false, username);
                            }
                        }
                        else
                        {
                            qtadd("Cannot autoban " + bnettext[1] + " for he has equal to or greater access.", whisper, username);
                        }
                    }
                }
                #endregion

                #region invite
                if (command == "invite")
                {
                    if (databasegetaccess(username) > 5)
                    {
                        BNSharp.MBNCSUtil.BncsPacket newpacket = new BNSharp.MBNCSUtil.BncsPacket(0x77);
                        newpacket.InsertDwordString("XX13");
                        newpacket.InsertCString(bnettext[1]);
                        qtadd("Inviting " + bnettext[1], whisper, username);
                        switch (set.Client.ToUpper())
                        {
                            case "WAR3":
                                client.Send(newpacket);
                                break;
                            case "W3XP":
                                client.Send(newpacket);
                                break;
                        }
                    }
                }
                #endregion

                #region tagban
                if (command == "tagban")
                {
                    if (databasegetaccess(username) >= 7)
                    {
                        if (tagban.exist(bnettext[1].ToLower()))
                        {
                            qtadd("Removing tagban: " + bnettext[1], whisper, username);
                            tagban.rem(bnettext[1].ToLower());
                            tagban.save();
                        }
                        else
                        {
                            qtadd("Adding tagban: " + bnettext[1], whisper, username);
                            tagban.add(bnettext[1].ToLower());
                            tagban.save();
                        }
                    }
                }
                #endregion

                #region say
                if (command == "say")
                {
                    if (databasegetaccess(username) > 8)
                    {
                        string tosend;
                        tosend = bnettext[1];
                        for (int i = 2; i < bnettext.Length; i++)
                        {
                            tosend = tosend + " " + bnettext[i];
                        }
                        qtadd(tosend, false, username);
                    }
                }
                #endregion

                #region ban
                if (command == "ban" || command == "b")
                {
                    int a = databasegetaccess(username);
                    if (a >= 7)
                    {
                        if (bnettext[1].Contains('*'))
                        {
                            string toban = bnettext[1].ToLower();
                            string tocheck = null;
                            string tosend1 = null;
                            if (bnettext.Length > 2)
                            {
                                for (int g = 2; g < bnettext.Length; g++)
                                {
                                    tosend1 = tosend1 + " " + bnettext[g];
                                }
                            }
                            List<clsChannel> inchannel = channel.FindAll(delegate(clsChannel u) { return u.inchannel == true; });
                            inchannel.ForEach(delegate(clsChannel u)
                            {
                                tocheck = u.username.ToLower().Replace("*", null);
                                if (tagban.wildcardcheck(toban, tocheck))
                                {
                                    if (databasegetaccess(u.username) == 0 && !u.isops)
                                    {
                                        qtadd("/ban " + u.username + tosend1, false, username);
                                        u.banned = true;
                                    }
                                }
                            });
                        }
                        else
                        {
                            int b = databasegetaccess(bnettext[1]);
                            if (a > b)
                            {
                                string tosend;
                                tosend = bnettext[1];
                                for (int i = 2; i < bnettext.Length; i++)
                                {
                                    tosend = tosend + " " + bnettext[i];
                                }
                                qtadd("/ban " + tosend, false, username);
                            }
                            else
                            {
                                qtadd("Cannot ban a user with equal or greater access", whisper, username);
                            }
                        }
                    }
                }
                #endregion

                #region unban
                if (command == "unban" || command == "u")
                {
                    if (databasegetaccess(username.ToLower()) >= 7)
                    {
                        if (bnettext[1].Contains("*"))
                        {
                            string tounban = bnettext[1].ToLower();
                            string tocheck = null;
                            List<clsChannel> isbanned = channel.FindAll(delegate(clsChannel u) { return u.banned == true; });
                            isbanned.ForEach(delegate(clsChannel u)
                            {
                                tocheck = u.username.ToLower().Replace("*", null);
                                if (tagban.wildcardcheck(tounban, tocheck))
                                {
                                    qtadd("/unban " + u.username, false, username);
                                }
                            });
                        }
                        else
                        {
                            qtadd("/unban " + bnettext[1], false, username);
                        }
                    }
                }
                #endregion

                #region kick
                if (command == "kick" || command == "k")
                {
                    int a = databasegetaccess(username.ToLower());
                    if (a >= 3)
                    {
                        if (bnettext[1].Contains('*'))
                        {
                            string toban = bnettext[1].ToLower();
                            string tocheck = null;
                            string tosend1 = null;
                            if (bnettext.Length > 2)
                            {
                                for (int g = 2; g < bnettext.Length; g++)
                                {
                                    tosend1 = tosend1 + " " + bnettext[g];
                                }
                            }
                            List<clsChannel> inchannel = channel.FindAll(delegate(clsChannel u) { return u.inchannel == true; });
                            inchannel.ForEach(delegate(clsChannel u)
                            {
                                tocheck = u.username.ToLower().Replace("*", null);
                                if (tagban.wildcardcheck(toban, tocheck))
                                {
                                    if (databasegetaccess(u.username.ToLower()) == 0 && !u.isops)
                                    {
                                        qtadd("/kick " + u.username + tosend1, false, username);
                                    }
                                }
                            });
                        }
                        else
                        {
                            int b = databasegetaccess(bnettext[1]);
                            if (a > b)
                            {
                                string tosend;
                                tosend = bnettext[1];
                                for (int i = 2; i < bnettext.Length; i++)
                                {
                                    tosend = tosend + " " + bnettext[i];
                                }
                                qtadd("/kick " + tosend, false, username);
                            }
                            else
                            {
                                qtadd("Cannot kick a user with equal or greater access", whisper, username);
                            }
                        }
                    }
                }
                #endregion

                #region whois
                if (command == "whois" || command == "find")
                {
                    if (databasegetaccess(username.ToLower()) >= 1)
                    {
                        string tosend = "";
                        int rcount = 0;
                        if (bnettext[1].Contains('*'))
                        {
                            List<clsDatabase> result = botdb.FindAll(delegate(clsDatabase u) { return tagban.wildcardcheck(bnettext[1].ToLower(), u.username) == true; });
                            result.ForEach(delegate(clsDatabase u)
                            {
                                if (rcount > 3)
                                {
                                    tosend = tosend + ", " + u.username + " : " + u.access;
                                    rcount = 0;
                                    qtadd(tosend, false, "");
                                    tosend = null;
                                }
                                else if (rcount == 0)
                                {
                                    rcount = 1;
                                    tosend = "Found User(s): " + u.username + " : " + u.access;
                                }
                                else
                                {
                                    rcount = rcount + 1;
                                    tosend = tosend + ", " + u.username + " : " + u.access;
                                }
                            });
                            if (tosend.Length > 1)
                            {
                                qtadd(tosend, false, "");
                            }
                        }
                        else
                        {
                            int a = System.Convert.ToInt32(databasegetaccess(bnettext[1].ToLower()));
                            if (a == 0)
                            {
                                qtadd("That user is not added.", whisper, username);
                            }
                            else
                            {
                                qtadd(bnettext[1] + " has the access of " + a, whisper, username);
                            }
                        }
                    }
                }
                #endregion

                #region set
                if (command == "set")
                {
                    int a = databasegetaccess(username);
                    if (a > 1)
                    {
                        int c = System.Convert.ToInt32(bnettext[2]);
                        string tocheck = "";
                        int ucount = 0;
                        string tosend = "";
                        if (bnettext[1].Contains('*'))
                        {
                            if (a > c)
                            {
                                List<clsChannel> inchannel = channel.FindAll(delegate(clsChannel u) { return u.inchannel == true; });
                                inchannel.ForEach(delegate(clsChannel u)
                                {
                                    tocheck = u.username.ToLower().Replace("*", null);
                                    if (tagban.wildcardcheck(bnettext[1], tocheck))
                                    {
                                        int b = databasegetaccess(u.username);
                                        if (databasegetaccess(u.username) < c)
                                        {
                                            if (ucount == 0)
                                            {
                                                tosend = "Set User(s): " + u.username;
                                                ucount++;
                                            }
                                            else if (ucount == 4)
                                            {
                                                tosend = tosend + ", " + u.username + " access to " + c;
                                                ucount = 0;
                                                qtadd(tosend, whisper, username);
                                            }
                                            else
                                            {
                                                tosend = tosend + ", " + u.username;
                                                ucount++;
                                            }
                                            databaseadd(u.username, c);
                                            databasesave();
                                        }
                                    }
                                });
                                if (tosend.Length > 0)
                                {
                                    tosend = tosend + " access to " + c;
                                    qtadd(tosend, whisper, username);
                                }
                            }
                        }
                        else
                        {
                            int b = databasegetaccess(bnettext[1]);
                            if (a > b)
                            {
                                if (a >= c)
                                {
                                    qtadd(bnettext[1] + " access has been changed from " + b + " to " + c + ".", whisper, username);
                                    databaseadd(bnettext[1], c);
                                    databasesave();
                                }
                                else
                                {
                                    qtadd("Cannot change access for " + bnettext[1] + " for you cannot add people with greater access.", whisper, username);
                                }
                            }
                            else
                            {
                                qtadd("Cannot change access for " + bnettext[1] + " for the user has greater or equal access to you.", whisper, username);
                            }
                        }
                    }
                }
                #endregion

                #region op
                if (command == "op")
                {
                    if (databasegetaccess(username.ToLower()) > 8)
                    {
                        bnetqueue.Clear();
                        qtadd("/designate " + bnettext[1], false, username);
                        qtadd("/rejoin", false, username);
                    }
                }
                #endregion

                #region ddp
                if (command == "ddp")
                {
                    if (set.Client.ToUpper() == "WAR3" || set.Client.ToUpper() == "W3XP")
                    {
                        if (databasegetaccess(username.ToLower()) > 8)
                        {
                            //BNSharp.MBNCSUtil.BncsPacket newpacket = new BNSharp.MBNCSUtil.BncsPacket(0x7d);
                            //newpacket.InsertDwordString(DateAndTime.Now.Ticks.ToString().Substring(1, 4));
                            //client.Send(newpacket);
                            bnetqueue.Clear();
                            QT1Count = 0;
                            toddp = bnettext[1];
                            QT1.Start();
                        }
                    }
                }
                #endregion

                #region ping
                if (command == "ping")
                    if (databasegetaccess(username.ToLower()) >= 1)
                    {
                        clsChannel check = channel.Find(delegate(clsChannel u) { return u.username.ToLower() == bnettext[1].ToLower(); });
                        if (check != null)
                        {
                            qtadd(bnettext[1] + " ping is: " + check.ping, whisper, username);
                        }
                    }
                #endregion
            }

            else
            {
                string command = message.ToLower();

                #region reconnect
                if (command == "reconnect" || command == "re")
                {
                    if (databasegetaccess(username.ToLower()) > 9)
                    {
                        client.Close();
                        client.Connect();
                        firstjoin = true;
                        bnetqueue.Clear();
                    }
                }
                #endregion

                #region quit
                if (command == "quit")
                {
                    if (databasegetaccess(username.ToLower()) > 9)
                    {
                        client.Close();
                        exit = true;
                    }
                }
                #endregion

                #region tagbans
                if (command == "tagbans")
                {
                    if (databasegetaccess(username.ToLower()) > 0)
                    {
                        ArrayList toarray = tagban.getlist();
                        int gg = 0;
                        string blank = null;
                        for (int i = 0; i != toarray.Count; i++)
                        {
                            if (gg <= 0)
                            {
                                blank = toarray[i].ToString();
                                gg = gg + 1;
                            }
                            else if (gg > 0 && gg < 6)
                            {
                                blank = blank + ", " + toarray[i].ToString();
                                gg = gg + 1;
                            }
                            else if (gg > 5)
                            {
                                qtadd("Tagbans: " + blank, whisper, username);
                                gg = 0;
                            }

                        }
                        qtadd("Tagbans: " + blank, whisper, username);
                    }
                }
                #endregion

                #region autobans
                if (command == "autobans")
                {
                    if (databasegetaccess(username.ToLower()) > 0)
                    {
                        ArrayList toarray = autoban.getlist();
                        int gg = 0;
                        string blank = null;
                        for (int i = 0; i != toarray.Count; i++)
                        {
                            if (gg <= 0)
                            {
                                blank = toarray[i].ToString();
                                gg = gg + 1;
                            }
                            else if (gg > 0 && gg < 5)
                            {
                                blank = blank + ", " + toarray[i].ToString();
                                gg = gg + 1;
                            }
                            else if (gg > 5)
                            {
                                qtadd("Autobans: " + blank, whisper, username);
                                gg = 0;
                            }

                        }
                        qtadd("Autobans: " + blank, whisper, username);
                    }
                }
                #endregion

                #region Reload
                if (command == "reload")
                {
                    if (databasegetaccess(username.ToLower()) >= 1)
                    {
                        qtadd("All settings reloaded.", whisper, username);
                        databaseload();
                        tagban.load();
                        autoban.load();
                    }
                }
                #endregion

                #region Uptime
                if (command == "uptime" || command == "timeup" || command == "info")
                {
                    if (databasegetaccess(username.ToLower()) >= 1)
                    {
                        qtadd(":+: " + SystemUptime() + " :+: " + BotUptime() + " :+:", whisper, username);
                    }
                }
                #endregion

                #region Lockdown
                if (command == "lockdown" || command == "protect")
                {
                    if (databasegetaccess(username.ToLower()) >= 8)
                    {
                        set.lockdown = toggle(set.lockdown);
                        set.save();
                        qtadd("Lockdown: " + status(set.lockdown), whisper, username);
                    }
                }
                #endregion

                #region bc
                if (command == "bc" || command == "bancount" || command == "info")
                {
                    if (databasegetaccess(username.ToLower()) >= 1)
                    {
                        List<clsChannel> isbanned = channel.FindAll(delegate(clsChannel u) { return u.banned == true; });
                        qtadd("Bancount: " + isbanned.Count, whisper, username);
                    }
                }
                #endregion

                #region cq
                if (command == "cq" || command == "clearqueue")
                {
                    if (databasegetaccess(username.ToLower()) >= 1)
                    {
                        bnetqueue.Clear();
                        qtadd("Queue Cleared.", whisper, username);
                    }
                }
                #endregion

                #region automod
                if (command == "automod" || command == "am")
                {
                    if (databasegetaccess(username.ToLower()) >= 7)
                    {
                        set.automod = toggle(set.automod);
                        qtadd("Automod: " + status(set.automod), whisper, username);
                        set.save();
                    }
                }
                #endregion

                #region pingban
                if (command == "pingban")
                {
                    if (databasegetaccess(username.ToLower()) >= 7)
                    {
                        set.pingban = toggle(set.pingban);
                        qtadd("Pingban: " + status(set.pingban), whisper, username);
                        set.save();
                    }
                }
                #endregion

                #region pingbans
                if (command == "pingbans")
                {
                    if (databasegetaccess(username) > 0)
                    {
                        qtadd("Pingbans: " + set.pingbans, whisper, username);
                    }
                }
                #endregion

                #region ver
                if (command == "ver" || command == "about" || command == "version")
                {
                    if (databasegetaccess(username.ToLower()) >= 1)
                    {
                        qtadd(myver, whisper, username);
                    }
                }
                #endregion

                #region whoami
                if (command == "whoami")
                {
                    if (databasegetaccess(username.ToLower()) >= 1)
                    {
                        qtadd("Your access is: " + databasegetaccess(username.ToLower()), whisper, username);
                    }
                }
                #endregion

                #region ping
                if (command == "ping")
                    if (databasegetaccess(username.ToLower()) >= 1)
                    {
                        clsChannel check = channel.Find(delegate(clsChannel u) { return u.username.ToLower() == username.ToLower(); });
                        if (check != null)
                        {
                            qtadd("Your ping is: " + check.ping, whisper, username);
                        }
                    }
                #endregion
            }

        }
        #endregion

        #region Database
        static int databasegetaccess(string toget)
        {
            toget = toget.Replace("*", null);
            clsDatabase check = botdb.Find(delegate(clsDatabase u) { return u.username.ToLower() == toget.ToLower(); });
            if (check != null)
            {
                return check.access;
            }
            else
            {
                return 0;
            }
        }
        static void databaseadd(string toadd, int acc)
        {
            toadd = toadd.Replace("*", null).ToLower();
            clsDatabase check = botdb.Find(delegate(clsDatabase u) { return u.username.ToLower() == toadd; });
            if (check != null)
            {
                int b = check.access;
                int c = System.Convert.ToInt32(acc);
                if (c == 0)
                {
                    botdb.Remove(check);
                }
                else
                {
                    if (b < acc)
                    {
                        check.access = acc;
                    }
                }
            }
            else
            {
                botdb.Add(new clsDatabase(toadd, acc));
            }
        }
        static void databaseload()
        {
            botdb.Clear();
            string basepath = Environment.CurrentDirectory;
            string filename;
            string txtline = "1";
            filename = basepath.Insert(basepath.Length, @"\database.txt");
            System.IO.StreamReader objReader;
            objReader = new System.IO.StreamReader(filename);

            do
            {
                txtline = objReader.ReadLine();
                if (txtline != null)
                {
                    if (txtline.Contains(':'))
                    {
                        string[] xx = txtline.Split(':');
                        int a = System.Convert.ToInt32(xx[1]);
                        xx[0] = xx[0].Replace("*", null);
                        clsDatabase check = botdb.Find(delegate(clsDatabase u) { return u.username.ToLower() == xx[0].ToLower(); });
                        if (check == null)
                        {
                            if ((a <= 10 & a >= 1))
                            {
                                botdb.Add(new clsDatabase(xx[0], a));
                            }
                        }
                    }
                }
            } while (objReader.Peek() != -1);
            objReader.Dispose();
            objReader.Close();
        }
        static void databasesave()
        {
            string basepath = Environment.CurrentDirectory;
            string filename;
            filename = basepath.Insert(basepath.Length, @"\database.txt");
            System.IO.StreamWriter objWriter;
            objWriter = new System.IO.StreamWriter(filename);
            botdb.ForEach(delegate(clsDatabase u) { objWriter.WriteLine(u.username.ToLower() + ":" + u.access); });
            objWriter.Close();
        }
        #endregion

        #region ddp
        static void QT1_Finshed(object sender, EventArgs e)
        {
            if (QT1Count == 0)
            {
                for (int i = 0; i != shamans.Count; i++)
                {
                    BNSharp.MBNCSUtil.BncsPacket newpacket = new BNSharp.MBNCSUtil.BncsPacket(0x7a);
                    newpacket.InsertDwordString("XXX" + i.ToString());
                    newpacket.InsertCString(shamans[i].ToString());
                    newpacket.InsertByte(0x02);
                    client.Send(newpacket);
                }
                QT1.Interval = 1500;
                QT1Count = 1;
            }
            else if (QT1Count == 1)
            {
                qtadd("/designate " + toddp, false, "");
                qtadd("/rejoin", false, "");
                QT1.Interval = 9500;
                QT1Count = 2;
            }
            else if (QT1Count == 2)
            {
                for (int i = 0; i != shamans.Count; i++)
                {
                    BNSharp.MBNCSUtil.BncsPacket newpacket = new BNSharp.MBNCSUtil.BncsPacket(0x7a);
                    newpacket.InsertDwordString("YYY" + i.ToString());
                    newpacket.InsertCString(shamans[i].ToString());
                    newpacket.InsertByte(0x03);
                    client.Send(newpacket);
                }
                QT1.Stop();
            }
        }
        #endregion

        #region queue
        static void QT2_Finshed(object sender, EventArgs e)
        {
            if (QT2Count >= 17000)
            {
                QT2Count = 17000;
            }
            else
            {
                QT2Count = QT2Count + 1000;
            }
        }
        static void QT_Finshed(object sender, EventArgs e)
        {
            for (int i = 0; i != 1; i++)
            {
                if (bnetqueue.Count >= 1)
                {
                    string todo = bnetqueue[0].ToString();
                    long count = 0;
                    if (todo.Contains(" "))
                    {
                        if (todo.Length > 0 & todo.Length <= 59)
                        {
                            count = 3500 + todo.Length * 32 + rnd(100, 1000);
                        }
                        else if (todo.Length >= 60)
                        {
                            count = 5000 + todo.Length * 42 + rnd(100, 500);
                        }
                        string[] ww = todo.Split(' ');
                        if (QT2Count - count > 0)
                        {
                            clsChannel check = channel.Find(delegate(clsChannel u) { return (u.username.ToLower() == ww[1].ToLower() && u.inchannel == true); });
                            if (ww[0] == @"/ban" && check != null)
                            {
                                if (!check.inchannel)
                                {
                                    bnetqueue.RemoveAt(0);
                                    break;
                                }
                            }
                            else if (ww[0] == @"/ban" && ww[1].ToLower().Replace("*", null) == (uniuser.ToLower()))
                            {
                                bnetqueue.RemoveAt(0);
                                break;
                            }
                            else if (ww[0] == @"/ban" && set.isd2 == true)
                            {
                                if (ww[1].Contains("*"))
                                {
                                }
                                else
                                {
                                    ww[1] = "*" + ww[1];
                                    todo = null;
                                    for (int x = 0; x != ww.Length; x++)
                                    {
                                        todo = todo + ww[x] + " ";
                                    }
                                }
                            }
                            else if (ww[0] == @"/unban" && set.isd2 == true)
                            {
                                if (ww[1].Contains("*"))
                                {
                                }
                                else
                                {
                                    ww[1] = "*" + ww[1];
                                    todo = null;
                                    for (int x = 0; x != ww.Length; x++)
                                    {
                                        todo = todo + ww[x] + " ";
                                    }
                                }
                            }
                            Console.WriteLine("<" + DateTime.Now.TimeOfDay + "> ME: {0}", todo);
                            client.SendMessage(Strings.Left(bnetqueue[0].ToString(), 230));
                            bnetqueue.RemoveAt(0);
                            QT2Count = QT2Count - count;
                            QT.Interval = 1;
                            break;

                        }
                    }
                    else
                    {
                        if (todo.Length > 0 & todo.Length <= 59)
                        {
                            count = 3500 + todo.Length * 32 + rnd(100, 700);
                        }
                        else if (todo.Length >= 60)
                        {
                            count = 5000 + todo.Length * 42 + rnd(100, 500);
                        }
                        if (QT2Count - count > 0)
                        {
                            Console.WriteLine("<" + DateTime.Now.TimeOfDay + "> ME: {0}", todo);
                            client.SendMessage(Strings.Left(bnetqueue[0].ToString(), 230));
                            bnetqueue.RemoveAt(0);
                            QT2Count = QT2Count - count;
                            QT.Interval = 1;
                            break;
                        }
                    }
                }
                else
                {

                }

            }
        }
        static void qtadd(string message, bool whisper, string username)
        {
            bool allowed = true;
            if (bnetqueue.Contains(@"/ban"))
            {
                if (bnetqueue.Contains(message))
                {

                }
                else
                {
                    string[] tosend = message.Split(' ');
                    for (int i = 0; i != bnetqueue.Count; i++)
                    {
                        string[] tocheck = bnetqueue[i].ToString().Split(' ');
                        if (tocheck[0] == @"/ban")
                        {
                            if (tocheck[1].ToLower() == tosend[1].ToLower())
                            {
                                allowed = false;
                                break;
                            }
                        }
                    }
                }
            }
            if (allowed)
            {
                if (whisper)
                {
                    if (message.Contains(' '))
                    {
                        if (set.Client == "D2DV" || set.Client == "D2XP")
                        {
                            message = "/w *" + username + " " + message;
                        }
                        else
                        {
                            message = "/w " + username + " " + message;
                        }
                    }
                    bnetqueue.Add(message);
                }
                else
                {
                    bnetqueue.Add(message);
                }
            }

        }
        #endregion

        #region battle.net events
        static void client_clan_memberstatus(object sender, BNSharp.BattleNet.Clans.ClanMemberStatusEventArgs e)
        {
            if (shamans.Contains(e.Member.Username.ToLower()))
            {
                if (e.Member.Rank.ToString().ToLower() != "shaman")
                {
                    shamans.Remove(e.Member.Username.ToLower());
                }
            }
            else
            {
                if (e.Member.Rank.ToString().ToLower() == "shaman")
                {
                    shamans.Add(e.Member.Username.ToLower());
                }
            }
        }
        static void client_clan_rankchange(object sender, BNSharp.BattleNet.Clans.ClanRankChangeEventArgs e)
        {

        }
        static void client_CList(object sender, BNSharp.BattleNet.Clans.ClanMemberListEventArgs e)
        {
            for (int i = 0; i != e.Members.Count; i++)
            {
                if (e.Members[i].Rank.ToString().ToLower() == "shaman")
                {
                    shamans.Add(e.Members[i].Username.ToLower());
                }
            }
        }
        static void client_JoinedChannel(object sender, BNSharp.ServerChatEventArgs e)
        {
            channel.ForEach(delegate(clsChannel u) { u.inchannel = false; });
            if (firstjoin == true)
            {
                if (e.Text.ToLower() != set.channel.ToLower())
                {
                    qtadd("/join " + set.channel, false, "");
                }
                firstjoin = false;
                //    QT2.Start();
            }
            Console.WriteLine("<" + DateTime.Now.TimeOfDay + "> JOINED CHANNEL: " + e.Text + " channel flags " + e.Flags);
        }
        static void client_UserShown(object sender, BNSharp.UserEventArgs e)
        {
            string user = null;
            if (e.User.Username.Contains('*'))
            {
                string[] userfix = e.User.Username.Split('*');
                user = "*" + userfix[1];
            }
            else
            {
                user = e.User.Username;
            }
            Console.WriteLine("<" + DateTime.Now.TimeOfDay + "> USER: {0} {1} {2} {3}", user, e.User.Stats.Product.ProductCode, e.User.Ping, e.User.Flags);
            string flags = e.User.Flags.ToString();
            bool isops;
            if (flags.ToLower() == "channeloperator")
            {
                isops = true;
            }
            else
            {
                isops = false;
            }
            if (e.User.Username.Replace("*", null) == uniuser)
            {
                if (flags.ToLower() == "channeloperator")
                {
                    ops = true;
                    Console.WriteLine("I HAVE ACQUIRED OPERATOR STATUS");
                }
                else
                {
                    ops = false;
                }
            }
            clsChannel check;
            check = channel.Find(delegate(clsChannel u) { return u.username.ToLower() == user.ToLower(); });
            if (check == null)
            {
                channel.Add(new clsChannel(user, e.User.Ping, 0, true, isops, e.User.Stats.Product.ProductCode, DateTime.Now.Ticks, 0, false));
            }
            else
            {
                check.ping = e.User.Ping;
                check.flags = 0;
                check.banned = false;
                check.client = e.User.Stats.Product.ProductCode;
                check.isops = isops;
                check.jointime = DateTime.Now.Ticks;
                check.lasttalk = 0;
                check.inchannel = true;
            }

        }
        static void client_UserJoined(object sender, BNSharp.UserEventArgs e)
        {
            string user = null;
            if (e.User.Username.Contains('*'))
            {
                string[] userfix = e.User.Username.Split('*');
                user = "*" + userfix[1];
            }
            else
            {
                user = e.User.Username;
            }
            bool isops = false;
            if (e.User.Flags.ToString().ToLower() == "channeloperator")
            {
                isops = true;
            }
            clsChannel check;
            check = channel.Find(delegate(clsChannel u) { return u.username.ToLower() == user.ToLower(); });
            if (check == null)
            {
                channel.Add(new clsChannel(user, e.User.Ping, 0, true, isops, e.User.Stats.Product.ProductCode, DateTime.Now.Ticks, 0, false));
                check = channel.Find(delegate(clsChannel u) { return u.username.ToLower() == user.ToLower(); });
            }
            else
            {
                check.ping = e.User.Ping;
                check.flags = 0;
                check.banned = false;
                check.client = e.User.Stats.Product.ProductCode;
                check.isops = isops;
                check.jointime = DateTime.Now.Ticks;
                check.lasttalk = 0;
                check.inchannel = true;
            }
            Console.WriteLine("<" + DateTime.Now.TimeOfDay + "> JOINED: {0} {1} {2} {3}", user, e.User.Stats.Product.ProductCode, e.User.Ping, e.User.Flags);
            if (ops == true)
            {
                Thread t = new Thread(delegate()
                   {
                       for (int g = 0; g != 1; g++)
                       {
                           int u = databasegetaccess(user.ToLower());
                           if (u < 1)
                           {
                               #region pingban
                               if (set.lockdown == true && !check.banned)
                               {
                                   qtadd(@"/ban " + e.User.Username + " Lockdown", false, "");
                                   break;
                               }
                               else if (set.pingban == true && !check.banned)
                               {
                                   int a = System.Convert.ToInt32(e.User.Ping);
                                   string y = null;
                                   if (set.pingbans.Contains(","))
                                   {
                                       string[] x = set.pingbans.Split(',');
                                       for (int i = 0; i != x.Length; i++)
                                       {
                                           if (x[i].Length > 1)
                                           {
                                               y = x[i].Substring(0, 1);
                                               x[i] = x[i].Remove(0, 1);
                                               if (y == ">")
                                               {
                                                   if (a > System.Convert.ToInt32(x[i]))
                                                   {
                                                       qtadd(@"/ban " + e.User.Username + " Pingban(" + a + ">" + System.Convert.ToInt32(x[i]) + ")", false, "");
                                                       check.banned = true;
                                                       break;
                                                   }
                                               }
                                               if (y == "<")
                                               {
                                                   if (a < System.Convert.ToInt32(x[i]))
                                                   {
                                                       qtadd(@"/ban " + e.User.Username + " Pingban(" + a + "<" + System.Convert.ToInt32(x[i]) + ")", false, "");
                                                       check.banned = true;
                                                       break;
                                                   }
                                               }
                                               if (y == "=")
                                               {
                                                   if (a == System.Convert.ToInt32(x[i]))
                                                   {
                                                       qtadd(@"/ban " + e.User.Username + " Pingban(" + a + "=" + System.Convert.ToInt32(x[i]) + ")", false, "");
                                                       check.banned = true;
                                                       break;
                                                   }
                                               }

                                           }
                                       }
                                   }
                                   else
                                   {
                                       if (set.pingbans.Length > 2)
                                       {
                                           y = set.pingbans.Substring(0, 1);
                                           string x = set.pingbans.Remove(0, 1);
                                           switch (y)
                                           {
                                               case ">":
                                                   if (a > System.Convert.ToInt32(x))
                                                   {
                                                       qtadd(@"/ban " + e.User.Username + " Pingban (" + a + ">" + System.Convert.ToInt32(x) + ")", false, "");
                                                       check.banned = true;
                                                   }
                                                   break;
                                               case "<":
                                                   if (a < System.Convert.ToInt32(x))
                                                   {
                                                       qtadd(@"/ban " + e.User.Username + " Pingban(" + a + "<" + System.Convert.ToInt32(x) + ")", false, "");
                                                       check.banned = true;
                                                   }
                                                   break;
                                               case "=":
                                                   if (a == System.Convert.ToInt32(x))
                                                   {
                                                       qtadd(@"/ban " + e.User.Username + " Pingban(" + a + "=" + System.Convert.ToInt32(x) + ")", false, "");
                                                       check.banned = true;
                                                   }
                                                   break;
                                           }
                                       }
                                   }
                                   break;
                               }
                               #endregion

                               #region autoban
                               else if (autoban.get(user.ToLower()) && !check.banned)
                               {
                                   qtadd(@"/ban " + e.User.Username + " Autoban", false, "");
                                   check.banned = true;
                                   break;
                               }
                               #endregion

                               #region tagcheck
                               else if (!check.banned)
                               {
                                   string tban = tagban.get(user);
                                   if (tban != null)
                                   {
                                       qtadd(@"/ban " + e.User.Username + " Tagban: " + tban, false, "");
                                       check.banned = true;
                                       break;
                                   }
                               }
                               #endregion

                               #region banevasion
                               else if (check.banned)
                               {
                                   qtadd(@"/ban " + e.User.Username + " Ban Evasion", false, "");
                                   break;
                               }
                               #endregion
                           }
                       }
                   });
                t.Start();
            }
        }
        static void client_UserLeft(object sender, BNSharp.UserEventArgs e)
        {
            string user = null;
            if (e.User.Username.Contains('*'))
            {
                string[] userfix = e.User.Username.Split('*');
                user = "*" + userfix[1];
            }
            else
            {
                user = e.User.Username;
            }
            clsChannel check;
            check = channel.Find(delegate(clsChannel u) { return u.username.ToLower() == user.ToLower(); });
            if (check == null)
            {
                channel.Add(new clsChannel(user, 0, 0, false, false, "", 0, 0, false));
            }
            else
            {
                check.isops = false;
                check.jointime = 0;
                check.lasttalk = 0;
                check.inchannel = false;
            }
            Console.WriteLine("<" + DateTime.Now.TimeOfDay + "> LEFT: {0}", user);
        }
        static void client_UserEmoted(object sender, BNSharp.ChatMessageEventArgs e)
        {
            string user = null;
            if (e.Username.Contains('*'))
            {
                string[] userfix = e.Username.Split('*');
                user = "*" + userfix[1];
            }
            else
            {
                user = e.Username;
            }
            clsChannel check;
            check = channel.Find(delegate(clsChannel u) { return u.username.ToLower() == user.ToLower(); });
            if (check == null)
            {

            }
            else
            {
                string jj1 = null;
                string jj2 = null;
                long ttime = 0;
                long ttime1 = 0;
                jj1 = check.jointime.ToString();
                jj1 = jj1.Substring(0, jj1.Length - 6);
                jj2 = DateTime.Now.Ticks.ToString();
                jj2 = jj2.Substring(0, jj2.Length - 6);
                ttime = System.Convert.ToInt64(jj1);
                ttime1 = System.Convert.ToInt64(jj2);
                ttime = ttime1 - ttime;
                if (ttime <= 10000)
                {
                    if (ops && set.automod && !check.isops)
                    {
                        qtadd(@"/ban " + user + " Automod", false, "");
                        check.banned = true;
                    }
                }
                else
                {
                    Console.WriteLine("<" + DateTime.Now.TimeOfDay + "> EMOTE: {0}:{1} | {2}", user, e.Flags, e.Text);

                    #region ?trigger
                    if (e.Text.ToLower().Equals("?trigger"))
                    {
                        if (databasegetaccess(user.ToLower()) > 0)
                        {
                            if (set.Trigger.Length > 1)
                            {
                                char[] a = set.Trigger.ToCharArray();
                                string RAWR = "";
                                for (int i = 0; i != a.Length; i++)
                                {
                                    int b = (int)a[i];
                                    if (i == 0)
                                    {
                                        if (b < 100)
                                        {
                                            RAWR = "Trigger is set to " + set.Trigger + " [ Alt + 0" + b + " ";
                                        }
                                        else
                                        {
                                            RAWR = "Trigger is set to " + set.Trigger + " [ Alt + " + b + " ";
                                        }
                                    }
                                    else if (i == (a.Length - 1))
                                    {
                                        if (b < 100)
                                        {
                                            RAWR = RAWR + "0" + b + "]";
                                        }
                                        else
                                        {
                                            RAWR = RAWR + b + "]";
                                        }
                                    }
                                    else
                                    {
                                        if (b < 100)
                                        {
                                            RAWR = RAWR + "0" + b + " ";
                                        }
                                        else
                                        {
                                            RAWR = RAWR + b + " ";
                                        }
                                    }

                                }
                                qtadd(RAWR, false, user);
                            }
                            else
                            {
                                char a = System.Convert.ToChar(set.Trigger);
                                int b = (int)a;
                                if (b < 100)
                                {
                                    qtadd("Trigger is set to " + set.Trigger + " [ Alt + 0" + b + " ] ", false, user);
                                }
                                else
                                {
                                    qtadd("Trigger is set to " + set.Trigger + " [ Alt + " + b + " ] ", false, user);
                                }
                            }
                        }
                    }
                    #endregion

                    if (e.Text.StartsWith(set.Trigger) || e.Text.StartsWith("\\"))
                    {
                        string work = "";
                        if (e.Text.StartsWith(set.Trigger))
                        {
                            work = e.Text.Substring(set.Trigger.Length);
                        }
                        else
                        {
                            work = e.Text.Substring(2);
                        }
                        if (work.Contains(";"))
                        {
                            char[] rawr = "; ".ToCharArray();
                            string[] splz = work.Split(';');
                            for (int i = 0; i != splz.Length; i++)
                            {
                                if (i > 0)
                                {
                                    splz[i] = splz[i].Substring(1);
                                }
                                commands(user, splz[i], false);
                            }
                        }
                        else
                        {
                            commands(user, work, false);
                        }
                    }
                }
            }
        }
        static void client_UserSpoke(object sender, BNSharp.ChatMessageEventArgs e)
        {
            string user = null;
            if (e.Username.Contains('*'))
            {
                string[] userfix = e.Username.Split('*');
                user = "*" + userfix[1];
            }
            else
            {
                user = e.Username;
            }
            clsChannel check;
            check = channel.Find(delegate(clsChannel u) { return u.username.ToLower() == user.ToLower(); });
            if (check == null)
            {

            }
            else
            {
                string jj1 = null;
                string jj2 = null;
                long ttime = 0;
                long ttime1 = 0;
                jj1 = check.jointime.ToString();
                jj1 = jj1.Substring(0, jj1.Length - 3);
                jj2 = DateTime.Now.Ticks.ToString();
                jj2 = jj2.Substring(0, jj2.Length - 3);
                ttime = System.Convert.ToInt64(jj1);
                ttime1 = System.Convert.ToInt64(jj2);
                ttime = ttime1 - ttime;
                if (ttime <= 10000)
                {
                    if (ops && set.automod && !check.isops)
                    {
                        qtadd(@"/ban " + user + " Automod", false, "");
                        check.banned = true;
                    }
                }
                else
                {
                    Console.WriteLine("<" + DateTime.Now.TimeOfDay + "> CHAT: {0}:{1} | {2}", user, e.Flags, e.Text);

                    #region ?trigger
                    if (e.Text.ToLower().Equals("?trigger"))
                    {
                        if (databasegetaccess(user.ToLower()) > 0)
                        {
                            if (set.Trigger.Length > 1)
                            {
                                char[] a = set.Trigger.ToCharArray();
                                string RAWR = "";
                                for (int i = 0; i != a.Length; i++)
                                {
                                    int b = (int)a[i];
                                    if (i == 0)
                                    {
                                        if (b < 100)
                                        {
                                            RAWR = "Trigger is set to " + set.Trigger + " [ Alt + 0" + b + " ";
                                        }
                                        else
                                        {
                                            RAWR = "Trigger is set to " + set.Trigger + " [ Alt + " + b + " ";
                                        }
                                    }
                                    else if (i == (a.Length - 1))
                                    {
                                        if (b < 100)
                                        {
                                            RAWR = RAWR + "0" + b + "]";
                                        }
                                        else
                                        {
                                            RAWR = RAWR + b + "]";
                                        }
                                    }
                                    else
                                    {
                                        if (b < 100)
                                        {
                                            RAWR = RAWR + "0" + b + " ";
                                        }
                                        else
                                        {
                                            RAWR = RAWR + b + " ";
                                        }
                                    }

                                }
                                qtadd(RAWR, false, user);
                            }
                            else
                            {
                                char a = System.Convert.ToChar(set.Trigger);
                                int b = (int)a;
                                if (b < 100)
                                {
                                    qtadd("Trigger is set to " + set.Trigger + " [ Alt + 0" + b + " ] ", false, user);
                                }
                                else
                                {
                                    qtadd("Trigger is set to " + set.Trigger + " [ Alt + " + b + " ] ", false, user);
                                }
                            }
                        }
                    }
                    #endregion

                    if (e.Text.StartsWith(set.Trigger) || e.Text.StartsWith("\\"))
                    {
                        string work = "";
                        if (e.Text.StartsWith(set.Trigger))
                        {
                            work = e.Text.Substring(set.Trigger.Length);
                        }
                        else
                        {
                            work = e.Text.Substring(2);
                        }
                        if (work.Contains(";"))
                        {
                            char[] rawr = "; ".ToCharArray();
                            string[] splz = work.Split(';');
                            for (int i = 0; i != splz.Length; i++)
                            {
                                if (i > 0)
                                {
                                    splz[i] = splz[i].Substring(1);
                                }
                                commands(user, splz[i], false);
                            }
                        }
                        else
                        {
                            commands(user, work, false);
                        }
                    }
                }
            }
        }
        static void client_WhisperReceived(object sender, BNSharp.ChatMessageEventArgs e)
        {
            string user = null;
            if (e.Username.Contains('*'))
            {
                string[] userfix = e.Username.Split('*');
                user = "*" + userfix[1];
            }
            else
            {
                user = e.Username;
            }
            Console.WriteLine("<" + DateTime.Now.TimeOfDay + "> WHISPER FROM: {0}:{1} | {2}", e.Username, e.Flags, e.Text);

            #region ?trigger
            if (e.Text.ToLower().Equals("?trigger"))
            {
                if (databasegetaccess(user.ToLower()) > 0)
                {
                    if (set.Trigger.Length > 1)
                    {
                        char[] a = set.Trigger.ToCharArray();
                        string RAWR = "";
                        for (int i = 0; i != a.Length; i++)
                        {
                            int b = (int)a[i];
                            if (i == 0)
                            {
                                if (b < 100)
                                {
                                    RAWR = "Trigger is set to " + set.Trigger + " [ Alt + 0" + b + " ";
                                }
                                else
                                {
                                    RAWR = "Trigger is set to " + set.Trigger + " [ Alt + " + b + " ";
                                }
                            }
                            else if (i == (a.Length - 1))
                            {
                                if (b < 100)
                                {
                                    RAWR = RAWR + "0" + b + "]";
                                }
                                else
                                {
                                    RAWR = RAWR + b + "]";
                                }
                            }
                            else
                            {
                                if (b < 100)
                                {
                                    RAWR = RAWR + "0" + b + " ";
                                }
                                else
                                {
                                    RAWR = RAWR + b + " ";
                                }
                            }

                        }
                        qtadd("1" + RAWR, true, user);
                    }
                    else
                    {
                        char a = System.Convert.ToChar(set.Trigger);
                        int b = (int)a;
                        if (b < 100)
                        {
                            qtadd("Trigger is set to " + set.Trigger + " [ Alt + 0" + b + " ] ", true, user);
                        }
                        else
                        {
                            qtadd("Trigger is set to " + set.Trigger + " [ Alt + " + b + " ] ", true, user);
                        }
                    }
                }
            }
            #endregion

            if (e.Text.StartsWith(set.Trigger) || e.Text.StartsWith("\\"))
            {
                string work = "";
                if (e.Text.StartsWith(set.Trigger))
                {
                    work = e.Text.Substring(set.Trigger.Length);
                }
                else
                {
                    work = e.Text.Substring(2);
                }
                if (work.Contains(";"))
                {
                    char[] rawr = "; ".ToCharArray();
                    string[] splz = work.Split(';');
                    for (int i = 0; i != splz.Length; i++)
                    {
                        if (i > 0)
                        {
                            splz[i] = splz[i].Substring(1);
                        }
                        commands(user, splz[i], true);
                    }
                }
                else
                {
                    commands(user, work, true);
                }
            }
        }
        static void client_Error(object sender, BNSharp.ErrorEventArgs e)
        {
            Console.WriteLine("<" + DateTime.Now.TimeOfDay + "> Error: {0}", e.Error);
        }
        static void client_EventExceptionThrown(object sender, BNSharp.EventExceptionEventArgs e)
        {
            Console.WriteLine("<" + DateTime.Now.TimeOfDay + "> Event Exception: {0}", e.EventName);
        }
        static void client_EnteredChat(object sender, BNSharp.EnteredChatEventArgs e)
        {
            Console.WriteLine("<" + DateTime.Now.TimeOfDay + "> Entered chat as {0}", e.UniqueUsername);
            uniuser = e.UniqueUsername;
        }
        static void client_ServerBroadcast(object sender, BNSharp.ServerChatEventArgs e)
        {
            Console.WriteLine("<" + DateTime.Now.TimeOfDay + "> Broadcast: {0}", e.Text);
        }
        static void client_Information(object sender, BNSharp.InformationEventArgs e)
        {
            Console.WriteLine("<" + DateTime.Now.TimeOfDay + "> INFO: {0}", e.Information);
        }
        static void client_InformationReceived(object sender, BNSharp.ServerChatEventArgs e)
        {
            Console.WriteLine("<" + DateTime.Now.TimeOfDay + "> INFO: {0}", e.Text);
            string[] todo = e.Text.Split(' ');
            if (todo.Length > 2)
            {
                string blarg = todo[2].ToLower();
                string user = todo[0].ToLower();
                clsChannel check = channel.Find(delegate(clsChannel u) { return u.username.ToLower() == user.ToLower(); });

                #region banned
                if (check != null)
                {
                    if (blarg.Equals("banned"))
                    {
                        if (check.banned)
                        {
                        }
                        else
                        {
                            check.banned = true;
                        }
                    }
                #endregion

                    #region unbanned
                    if (blarg.Equals("unbanned"))
                    {
                        if (check.banned)
                        {
                            check.banned = false;
                        }
                    }
                }
                    #endregion
            }
        }
        static void client_UserFlagsChanged(object sender, BNSharp.UserEventArgs e)
        {
            string user = null;
            if (e.User.Username.Contains('*'))
            {
                string[] userfix = e.User.Username.Split('*');
                user = "*" + userfix[1];
            }
            else
            {
                user = e.User.Username;
            }
            Console.WriteLine("<" + DateTime.Now.TimeOfDay + "> FLAGS: {0} {1} {2}", user, e.User.Ping, e.User.Flags);
            string flags = e.User.Flags.ToString();
            clsChannel check = channel.Find(delegate(clsChannel u) { return u.username.ToLower() == user.ToLower(); });
            if (flags.ToLower() == "channeloperator")
            {
                check.isops = true;
            }
            else
            {
                check.isops = false;
            }
            if (e.User.Username.Replace("*", null) == uniuser)
            {
                if (flags.ToLower() == "channeloperator")
                {
                    ops = true;
                    Console.WriteLine("I HAVE ACQUIRED OPERATOR STATUS");
                }
                else
                {
                    ops = false;
                }
            }
        }
        static void client_HashResult(object sender, BNSharp.ClientCheckFailedEventArgs e)
        {
            Console.WriteLine("{0}", e.Reason);
            switch (e.Reason.ToString().ToLower())
            {
                case "invalidversion":
                    {
                        downloadhashes = true;
                        break;
                    }
                default:
                    {
                        downloadhashes = false;
                        break;
                    }
            }
            if (downloadhashes == true)
            {
                string x = set.Client;
                hashupdate(x);
                //Console.WriteLine("Downloading new verbytes...");
                //WebClient Web = new WebClient();
                //string x = null;
                //Web.DownloadFile("http://mikeownage.com/downloads/shubot/verbytes.txt", "verbytes.txt");
                //Console.WriteLine("Download of verbytes complete.. Starting Hash Download...");
                //Console.WriteLine("Please close the bot and delete the old hash files.");
            }


        }
        #endregion

        #region hash update
        static void hashupdate(string thegame)
        {
            string basepath = Environment.CurrentDirectory;
            Console.WriteLine("Downloading new verbytes and hashes please wait...");
            WebClient Web = new WebClient();
            string x = null;
            Web.DownloadFile("http://mikeownage.com/downloads/shubot/verbytes.txt", "verbytes.txt");
            Console.WriteLine("Download of verbytes complete.. Starting Hash Download...");
            switch (thegame.ToLower())
            {
                case "star":
                    {
                        x = "STAR.zip";
                        Web.DownloadFile("http://mikeownage.com/downloads/battle.net/" + x, x);
                        UnZip.Unzipfile(basepath + @"\" + x, basepath + @"\Hashes\");
                        break;
                    }
                case "sexp":
                    {
                        x = "STAR.zip";
                        Web.DownloadFile("http://mikeownage.com/downloads/battle.net/" + x, x);
                        UnZip.Unzipfile(basepath + @"\" + x, basepath + @"\Hashes\");
                        break;
                    }
                case "d2dv":
                    {
                        x = "D2DV.zip";
                        Web.DownloadFile("http://mikeownage.com/downloads/battle.net/" + x, x);
                        UnZip.Unzipfile(basepath + @"\" + x, basepath + @"\Hashes\");
                        break;
                    }
                case "d2xp":
                    {
                        x = "D2XP.zip";
                        Web.DownloadFile("http://mikeownage.com/downloads/battle.net/" + x, x);
                        UnZip.Unzipfile(basepath + @"\" + x, basepath + @"\Hashes\");
                        break;
                    }
                case "w2bn":
                    {
                        x = "W2BN.zip";
                        Web.DownloadFile("http://mikeownage.com/downloads/battle.net/" + x, x);
                        UnZip.Unzipfile(basepath + @"\" + x, basepath + @"\Hashes\");
                        break;
                    }
                case "war3":
                    {
                        x = "WAR3.zip";
                        Web.DownloadFile("http://mikeownage.com/downloads/battle.net/" + x, x);
                        UnZip.Unzipfile(basepath + @"\" + x, basepath + @"\Hashes\");
                        break;
                    }
                case "w3xp":
                    {
                        x = "WAR3.zip";
                        Web.DownloadFile("http://mikeownage.com/downloads/battle.net/" + x, x);
                        UnZip.Unzipfile(basepath + @"\" + x, basepath + @"\Hashes\");
                        break;
                    }
            }
            Console.WriteLine("Download of hashes complete.. Please restart the bot.");
            File.Delete(basepath + @"\" + x);
        }
        #endregion

    }

    public class clsChannel
    {
        #region declares
        public string username;
        public long ping;
        public long jointime;
        public long lasttalk;
        public string client;
        public bool isops;
        public long flags;
        public bool banned;
        public bool inchannel;
        #endregion
        public clsChannel(string username, long ping, long flags, bool inchannel, bool isops, string client, long jointime, long lasttalk, bool banned)
        {
            this.ping = ping;
            this.flags = flags;
            this.isops = isops;
            this.client = client;
            this.jointime = jointime;
            this.lasttalk = lasttalk;
            this.username = username;
            this.banned = banned;
            this.inchannel = inchannel;
        }

    }

    public class clsDatabase
    {
        #region declares
        public string username;
        public int access;
        #endregion
        public clsDatabase(string username, int access)
        {
            this.username = username;
            this.access = access;
        }

    }

    class clsBotdb
    {
        #region declares
        private ArrayList users = new ArrayList();
        private ArrayList access = new ArrayList();
        #endregion

        #region main
        public void load()
        {
            users.Clear();
            string basepath = Environment.CurrentDirectory;
            string filename;
            string txtline = "1";
            filename = basepath.Insert(basepath.Length, @"\database.txt");
            System.IO.StreamReader objReader;
            objReader = new System.IO.StreamReader(filename);

            do
            {
                txtline = objReader.ReadLine();
                if (txtline != null)
                {
                    if (txtline.Contains(':'))
                    {
                        string[] xx = txtline.Split(':');
                        int a = System.Convert.ToInt32(xx[1]);
                        xx[0] = xx[0].Replace("*", null);
                        if ((a <= 10 & a >= 1))
                        {
                            users.Add(xx[0].ToLower());
                            access.Add(xx[1]);
                        }
                    }
                }
            } while (objReader.Peek() != -1);
            objReader.Dispose();
            objReader.Close();
        }
        public void save()
        {
            string basepath = Environment.CurrentDirectory;
            string filename;
            filename = basepath.Insert(basepath.Length, @"\database.txt");
            System.IO.StreamWriter objWriter;
            objWriter = new System.IO.StreamWriter(filename);
            for (int i = 0; i < users.Count; i++)
            {
                objWriter.WriteLine(users[i].ToString() + ":" + access[i].ToString());
            }
            objWriter.Close();
        }
        public void add(string toadd, int acc)
        {
            toadd = toadd.Replace("*", null);
            if (users.Contains(toadd))
            {
                int a = users.IndexOf(toadd.ToLower());
                int b = System.Convert.ToInt32(access[a].ToString());
                int c = System.Convert.ToInt32(acc);
                if (c == 0)
                {
                    if (users.Contains(toadd.ToLower()))
                    {
                        users.RemoveAt(a);
                        access.RemoveAt(a);
                    }
                }
                else
                {
                    if (b < acc)
                    {
                        users.RemoveAt(a);
                        access.RemoveAt(a);
                        users.Add(toadd);
                        access.Add(acc);
                    }
                }
            }
            else
            {
                users.Add(toadd);
                access.Add(acc);
            }
        }
        public void rem(string torem)
        {
            torem = torem.Replace("*", null);
            if (users.Contains(torem))
            {
                int a = users.IndexOf(torem);
                users.RemoveAt(a);
                access.RemoveAt(a);
            }
            else
            {

            }
        }
        public int getaccess(string toget)
        {
            toget = toget.Replace("*", null);
            if (users.Contains(toget))
            {
                int x = users.IndexOf(toget);
                int a = System.Convert.ToInt32(access[x]);
                return a;
            }
            else
            {
                return 0;
            }
        }
        #endregion
    }

    class clsAutoban
    {
        #region declares
        static ArrayList users = new ArrayList();
        #endregion

        #region main
        public void load()
        {
            users.Clear();
            string basepath = Environment.CurrentDirectory;
            string filename;
            string txtline = "1";
            filename = basepath.Insert(basepath.Length, @"\autoban.txt");
            System.IO.StreamReader objReader;
            objReader = new System.IO.StreamReader(filename);

            do
            {
                txtline = objReader.ReadLine();
                if (txtline != null)
                {
                    if (users.Contains(txtline))
                    {

                    }
                    else
                    {
                        users.Add(txtline.ToLower());
                    }
                }
            } while (objReader.Peek() != -1);
            objReader.Dispose();
            objReader.Close();
        }
        public void save()
        {
            string basepath = Environment.CurrentDirectory;
            string filename;
            filename = basepath.Insert(basepath.Length, @"\autoban.txt");
            System.IO.StreamWriter objWriter;
            objWriter = new System.IO.StreamWriter(filename);
            for (int i = 0; i < users.Count; i++)
            {
                objWriter.WriteLine(users[i].ToString());
            }
            objWriter.Close();
        }
        public void add(string toadd)
        {
            toadd = toadd.Replace("*", null);
            if (users.Contains(toadd))
            {

            }
            else
            {
                users.Add(toadd);
            }
        }
        public void rem(string torem)
        {
            torem = torem.Replace("*", null);
            if (users.Contains(torem))
            {
                int a = users.IndexOf(torem);
                users.RemoveAt(a);
            }
            else
            {

            }
        }
        public bool get(string toget)
        {
            toget = toget.Replace("*", null);
            if (users.Contains(toget))
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        public ArrayList getlist()
        {
            return users;
        }
        #endregion
    }

    class clsTagban
    {
        #region declares
        static ArrayList users = new ArrayList();
        #endregion

        #region main
        public void load()
        {
            users.Clear();
            string basepath = Environment.CurrentDirectory;
            string filename;
            string txtline = "1";
            filename = basepath.Insert(basepath.Length, @"\tagbans.txt");
            System.IO.StreamReader objReader;
            objReader = new System.IO.StreamReader(filename);

            do
            {
                txtline = objReader.ReadLine();
                if (txtline != null)
                {
                    if (users.Contains(txtline))
                    {

                    }
                    else
                    {
                        users.Add(txtline.ToLower());
                    }
                }
            } while (objReader.Peek() != -1);
            objReader.Dispose();
            objReader.Close();
        }
        public void save()
        {
            string basepath = Environment.CurrentDirectory;
            string filename;
            filename = basepath.Insert(basepath.Length, @"\tagbans.txt");
            System.IO.StreamWriter objWriter;
            objWriter = new System.IO.StreamWriter(filename);
            for (int i = 0; i < users.Count; i++)
            {
                objWriter.WriteLine(users[i].ToString());
            }
            objWriter.Close();
        }
        public void add(string toadd)
        {
            if (users.Contains(toadd))
            {

            }
            else
            {
                users.Add(toadd);
            }
        }
        public void rem(string torem)
        {
            if (users.Contains(torem))
            {
                int a = users.IndexOf(torem);
                users.RemoveAt(a);
            }
            else
            {

            }
        }
        public string get(string toget)
        {
            for (int i = 0; i != users.Count; i++)
            {
                string todo = users[i].ToString().ToLower();
                string tocheck = toget.ToLower().Replace("*", "");
                if (wildcardcheck(todo, tocheck))
                {
                    return users[i].ToString();
                }
            }
            return null;
        }
        public bool exist(string toget)
        {
            if (users.Contains(toget))
            {
                return true;
            }
            return false;
        }
        public ArrayList getlist()
        {
            return users;
        }
        public string formatforcheck(string B)
        {
            B = B.Replace("@uswest", null);
            B = B.Replace("@useast", null);
            B = B.Replace("@asia", null);
            B = B.Replace("@europe", null);
            B = B.Replace("@lordaeron", null);
            B = B.Replace("@azeroth", null);
            B = B.Replace("@northrend", null);
            B = B.Replace("@kalimdor", null);
            B = B.Replace("*", null);
            return B;
        }
        public bool wildcardcheck(string A, string B)
        {
            A = A.ToLower();
            B = formatforcheck(B).ToLower();
            if ((Strings.Left(A, 1) == "*") && (Strings.Right(A, 1) == "*"))
            {
                A = A.Replace("*", null);
                for (int i = 1; i != B.Length + 1; i++)
                {
                    if (Strings.Mid(B, i, A.Length) == A)
                    {
                        return true;
                    }
                }
            }
            else if (Strings.Left(A, 1) == "*")
            {
                A = A.Replace("*", null);
                if (Strings.Right(B, A.Length) == A)
                {
                    return true;
                }
            }
            else if (Strings.Right(A, 1) == "*")
            {
                A = A.Replace("*", null);
                if (Strings.Left(B, A.Length) == A)
                {
                    return true;
                }
            }
            else
            {
                return false;
            }
            return false;
        }
        #endregion
    }

    class UnZip
    {
        public static string Unzipfile(string ZipPath, string UnzipPath)
        {
            try
            {
                ZipInputStream s = new ZipInputStream(File.OpenRead(ZipPath));
                ZipEntry ZEntry;
                FileStream streamWriter = null;
                //string tempDir = null;
                string sFileName = null;

                while ((ZEntry = s.GetNextEntry()) != null)
                {
                    string directoryName = null;
                    //string strdirectoryName = null;
                    try
                    {

                        directoryName = Path.GetDirectoryName(ZEntry.Name);
                        if (!Directory.Exists(UnzipPath + "\\" + directoryName))
                        {
                            Directory.CreateDirectory(UnzipPath + "\\" +
directoryName);
                        }
                    }
                    catch (Exception ex)
                    {
                        throw new ApplicationException(ex.Message);
                    }

                    sFileName = Path.GetFileName(ZEntry.Name);
                    try
                    {
                        if (sFileName != String.Empty)
                        {
                            streamWriter = File.Create(UnzipPath + "\\" +
directoryName + "\\" + sFileName);

                            int size = 20480;
                            byte[] data = new byte[20480];
                            while (true)
                            {
                                size = s.Read(data, 0, data.Length);
                                if (size > 0)
                                {
                                    streamWriter.Write(data, 0, size);
                                }
                                else
                                {
                                    break;
                                }
                            }

                            streamWriter.Close();
                        }
                    }
                    catch (Exception ex)
                    {
                        throw new ApplicationException(ex.Message);
                    }
                }

                if (streamWriter != null)
                {
                    streamWriter.Close();
                }
                s.Close();
                return sFileName;
            }
            catch (Exception ex)
            {
                return ex.Message;
            }
        }
    }
}
